Developer Documentation

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Modules Pages
Public Types | Public Member Functions | Private Member Functions | Private Attributes | List of all members
ACG::KnotvectorT< Scalar > Class Template Reference

`#include <ObjectTypes/Knotvector/KnotvectorT.hh>`

## Public Types
enum | KnotvectorType { UNIFORM_INTERPOL = 0, UNIFORM = 1 }

## Public Member Functions
| KnotvectorT ()
| Constructor.
| KnotvectorT (const KnotvectorT &_knotvec)
| Copy Constructor.
| ~KnotvectorT ()
| Destructor.
void | setType (KnotvectorType _type)
void | createKnots (unsigned int _splineDeg, unsigned int _dim)
std::vector< Scalar > & | getKnotvector ()
const std::vector< Scalar > & | getKnotvector () const
unsigned int | size () const
Scalar | getKnot (unsigned int _index) const
void | setKnotvector (const std::vector< Scalar > &_knots)
void | resize (unsigned int _size)
void | insertKnot (unsigned int _index, const Scalar _knot)
void | addKnot (Scalar _knot)
void | setKnot (unsigned int _index, Scalar _knot)
void | deleteKnot (unsigned int _index)
Scalar & | operator() (unsigned int _index)
| returns a reference to the _index'th knot More...
const Scalar & | operator() (unsigned int _index) const
| returns a const reference to the _index'th knot More...
void | clear ()
void | request_selections ()
void | release_selections ()
bool | selections_available () const
unsigned char & | selection (unsigned int _i)
const unsigned char & | selection (unsigned int _i) const
void | select (unsigned int _pIdx)
void | deselect (unsigned int _pIdx)
bool | selected (unsigned int _pIdx) const

## Private Member Functions
template<class PropT >
void | request_prop (unsigned int &_ref_count, PropT &_prop)
template<class PropT >
void | release_prop (unsigned int &_ref_count, PropT &_prop)
void | createUniformInterpolatingKnots (unsigned int _splineDeg, unsigned int _dim)
void | createUniformKnots (unsigned int _splineDeg, unsigned int _dim)

## Private Attributes
std::vector< unsigned char > | selections_
unsigned int | ref_count_selections_
std::vector< Scalar > | knots_
KnotvectorType | knotvectorType_
unsigned int | num_control_points_
unsigned int | spline_degree_

## Detailed Description

### template<typename Scalar>
class ACG::KnotvectorT< Scalar >

A knotvector class for use with splines

Definition at line 84 of file KnotvectorT.hh.

## Member Function Documentation

template<typename Scalar>

Scalar& ACG::KnotvectorT< Scalar >::operator() | ( | unsigned int | _index | ) |
| inline

returns a reference to the _index'th knot

Parameters

  _index | The knot index

Definition at line 136 of file KnotvectorT.hh.

template<typename Scalar>

const Scalar& ACG::KnotvectorT< Scalar >::operator() | ( | unsigned int | _index | ) | const
| inline

returns a const reference to the _index'th knot

Parameters

  _index | The knot index

Definition at line 145 of file KnotvectorT.hh.

The documentation for this class was generated from the following files:

- ObjectTypes/Knotvector/KnotvectorT.hh
- ObjectTypes/Knotvector/KnotvectorT.cc